/* config.h */ 

/* ports */
#define RIGHT_MOTOR NXT_PORT_A
#define LEFT_MOTOR NXT_PORT_C
#define STEERING_MOTOR NXT_PORT_B

#define LIGHT_PORT  NXT_PORT_S3
#define SONIC_PORT  NXT_PORT_S1
#define TOUCH_REAR_PORT  NXT_PORT_S2
#define TOUCH_FRONT_PORT  NXT_PORT_S4

/* states */
#define INIT 0
#define NONE 1
#define LIGHT_RULE 3
#define TOUCH_RULE 2
#define SONIC_RULE 4

/* time outs */
#define LIGHT_TURN_TIME 500U
#define TOUCH_BACK_TIME 750U
#define SONIC_TURN_TIME 500U

/* threshold */
#define BLUE_LIGHT_THRESHOLD 360
#define DISTANCE_THRESHOLD 20

#define STEERING_LIMIT             35 /* degree */
#define STEERING_P_GAIN             2 /* proportinal gain */
#define DIFF_GAIN_MAX            0.7F /* 1.0-DIFF_GAIN_MAX: max. differential effect */
#define PWM_OFFSET                 10 /* friction compensator */
